<?php 
     require 'vendor/autoload.php';
     use SMSGatewayMe\Client\ApiClient;
     use SMSGatewayMe\Client\Configuration;
     use SMSGatewayMe\Client\Api\MessageApi;
     use SMSGatewayMe\Client\Model\SendMessageRequest;

    Class InsertClient{

        private $dbc;
        private $config;
        private $apiClient;
        private $messageClient;
        
        public function __construct() {
                    date_default_timezone_set('Asia/Manila');

                  $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast2") or die(mysqli_connect_error());
            // Configure client
            $this->config = Configuration::getDefaultConfiguration();
            $this->config->setApiKey('Authorization', 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJhZG1pbiIsImlhdCI6MTY2NjA3MjU1MCwiZXhwIjo0MTAyNDQ0ODAwLCJ1aWQiOjk1NTgyLCJyb2xlcyI6WyJST0xFX1VTRVIiXX0.wKWW1PkJljCP5FjLDV5kckmf-OAWFXelx9EmYc_X_v8');
            $this->apiClient = new ApiClient($this->config);
            $this->messageClient = new MessageApi($this->apiClient);

        }

        public function insertData($data, $msg){
          

            foreach($data as $dat){
                $formatNo = str_replace(' ', '', $dat[0]);
                $no = $this->dbc->real_escape_string($formatNo);
                $name = $this->dbc->real_escape_string($dat[1]);
                
                if(isset($dat[1]) && !empty($dat[1]) ){
                    $msg = $dat[1];    
                }
                
                $formatMesage = str_replace('[name]', $dat[1], $msg);
                $newMsg = $this->dbc->real_escape_string($formatMesage);
                if($this->validatePhoneNo($no)){
                    $insertTo = "('".$no."', '". $newMsg."', '". $name."' , 0)";
                    if(!mysqli_query($this->dbc, "INSERT INTO `client` (`contact_no`, `message`,`name`,  `status`) VALUES $insertTo "))

                    die(mysqli_error($this->dbc));

                }
            }
            

        }
        
        public function validatePhoneNo($phoneNo){
        
            $isVAlid = false;
            if(preg_match("/^(09|\+639)\d{9}$/", $phoneNo)) {
                $isVAlid = true;
            }
            
            return $isVAlid;
            
        }


        public function isSending(){
            
            $isSending = false;

            $q = mysqli_query($this->dbc, "
                SELECT 
                    c.`id`
                FROM `client` c
                WHERE c.`status` = 0
                AND c.`created_at` BETWEEN '".date('Y-m-d')." 00:00:00' AND '".date('Y-m-d')." 23:59:59' 
                AND c.`company` IS NULL
            ");

            if($q->num_rows > 0){
                $isSending = true;
            }
           
            return $isSending;
        }

        
    }

?>