<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

Class SendSms {

    private $dbc;
    private $config;
    private $apiClient;
    private $messageClient;

    public function __construct() {
            date_default_timezone_set('Asia/Manila');

            $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcawnj_dev", "!tryMe123", "vetcawnj_textblast") or die(mysqli_connect_error());
            // Configure client
            $this->config = Configuration::getDefaultConfiguration();
            $this->config->setApiKey('Authorization', 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJhZG1pbiIsImlhdCI6MTY2NjA3MjU1MCwiZXhwIjo0MTAyNDQ0ODAwLCJ1aWQiOjk1NTgyLCJyb2xlcyI6WyJST0xFX1VTRVIiXX0.wKWW1PkJljCP5FjLDV5kckmf-OAWFXelx9EmYc_X_v8');
            $this->apiClient = new ApiClient($this->config);
            $this->messageClient = new MessageApi($this->apiClient);

    }

     public function execute() {
        
            $q = mysqli_query($this->dbc, "
                SELECT 
                    c.`contact_no`,
                    c.`message`,
                    c.`status`,
                    c.`id`,
                    c.`company`,
                    c.`date_return`
                FROM `client` c
                WHERE c.`status` = 0
                AND c.`sms_status` != 'Invalid Contact No'
            ");

      
        if($q->num_rows > 0){
            $ctr = 0;
            while ($row = mysqli_fetch_assoc($q)) {
                if(!in_array($row['company'], [''])){
                    if(!in_array($row['company'] , [
                    "Man's Best Friend Veterinary Clinic",
                    "Man's Best Friend Veterinary Clinic - Concepcion",
                    "Man's Best Friend Veterinary Clinic - Masinag",
                    "Man's Best Friend Veterinary Clinic - Bataan",
                    "Man's Best Friend Veterinary Clinic - Naga"])){
                    

                        $sendMessages = $this->messageClient->sendMessages([
                            new SendMessageRequest([
                                'phoneNumber' => $row['contact_no'],
                                //'phoneNumber' => '09816133814',
                                'message' => $row['message'],
                                'deviceId' => 129212
                            ])
                        ]);

        
                        if(!mysqli_query($this->dbc, "UPDATE `client` c SET c.`status` = 1, c.`sms_id` = ".$sendMessages[0]->getId()." WHERE c.`id` = ".$row['id'].""))
                        die(mysqli_error($this->dbc));
                        
                        $ctr++;
                        echo "Message sent to: " . $row['contact_no'] .  "\n" ;

                        if($ctr == 40){
                            echo $ctr;
                            break;
                        }
                    } else {
                        
                        $dateReturn = substr($row['date_return'], 0, strpos($row['date_return'], "T"));

                        if($dateReturn == date('Y-m-d') && date('H') >= 6){
                            $sendMessages = $this->messageClient->sendMessages([
                                new SendMessageRequest([
                                    'phoneNumber' => $row['contact_no'],
                                    //'phoneNumber' => '09816133814',
                                    'message' => $row['message'],
                                    'deviceId' => 129212
                                ])
                            ]);
                            
            
                            if(!mysqli_query($this->dbc, "UPDATE `client` c SET c.`status` = 1, c.`sms_id` = ".$sendMessages[0]->getId()." WHERE c.`id` = ".$row['id'].""))
                            die(mysqli_error($this->dbc));
                            
                            $ctr++;
                            echo "Message sent to: " . $row['contact_no'] .  "\n" ;
                            
                            if($ctr == 40){
                                echo $ctr;
                                break;
                            }
                            
                        } else {
                            echo $row['company'] ;
                            echo "schedule is not yet ready" .  "\n" ;
                        }
                       
                    }
                } else {
                    echo $row['company'] ;
                    echo "Company SMS is deactivated" .  "\n" ;
                }
                
                

            }
        } else {
            echo 'Theres no sms to sent';
        }
       
        
    }
}

$sms = new SendSms();
$sms->execute();