<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

Class SentAppointmentMessages {

    private $dbc;
    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcawnj_dev", "!tryMe123", "vetcawnj_textblast") or die(mysqli_connect_error());
    }

    public function getAllSentSms($company){

        $am = date('Y-m-d 00:00:00');
        $pm = date('Y-m-d 23:59:59');

        $andWhere = '';

        if($company != ''){

            $andWhere.= ' AND c.`company` LIKE "%'.str_replace('_', ' ', $company).'%"';
        } 

        $q =mysqli_query($this->dbc, "SELECT 
                c.`contact_no`,
                c.`message`,
                c.`status`,
                c.`client`,
                c.`company`,
                c.`schedule_date_created`,
                c.`id`,
                DATE_FORMAT(c.`created_at`, '%Y/%m/%d') as createdAt
            FROM `client` c
            WHERE c.`status` = 1
            ".$andWhere."
            AND c.`contact_no` IS NOT NULL
            AND c.`message`  IS NOT NULL
            AND c.`company` IS NOT NULL
            AND c.`client`  IS NOT NULL
            AND c.`created_at` BETWEEN '".$am."' AND '".$pm."'");
       
         
        return mysqli_fetch_all($q, MYSQLI_ASSOC);
    }
}

$sms = new SentAppointmentMessages();
