<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

Class SendTextBlast {

    private $dbc;
    private $config;
    private $apiClient;
    private $messageClient;

    public function __construct() {
            date_default_timezone_set('Asia/Manila');

            $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcawnj_dev", "!tryMe123", "vetcawnj_textblast2") or die(mysqli_connect_error());
            // Configure client
            $this->config = Configuration::getDefaultConfiguration();
            $this->config->setApiKey('Authorization', 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJhZG1pbiIsImlhdCI6MTY2NjA3MjU1MCwiZXhwIjo0MTAyNDQ0ODAwLCJ1aWQiOjk1NTgyLCJyb2xlcyI6WyJST0xFX1VTRVIiXX0.wKWW1PkJljCP5FjLDV5kckmf-OAWFXelx9EmYc_X_v8');
            $this->apiClient = new ApiClient($this->config);
            $this->messageClient = new MessageApi($this->apiClient);

    }

     public function execute() {
        
            $q = mysqli_query($this->dbc, "
                SELECT 
                    c.`contact_no`,
                    c.`message`,
                    c.`status`,
                    c.`id`
                FROM `client` c
                WHERE c.`status` = 0
                LIMIT 40
            ");

      
        if($q->num_rows > 0){
            while ($row = mysqli_fetch_assoc($q)) {
                $sendMessages = $this->messageClient->sendMessages([
                    new SendMessageRequest([
                        'phoneNumber' => $row['contact_no'],
                        //'phoneNumber' => '09816133814',
                        'message' => $row['message'],
                        'deviceId' => 129212
                    ])
                ]);
                

                if(!mysqli_query($this->dbc, "UPDATE `client` c SET c.`status` = 1, c.`sms_id` = ".$sendMessages[0]->getId()." WHERE c.`id` = ".$row['id'].""))
                die(mysqli_error($this->dbc));

                echo "Message sent to: " . $row['contact_no'] .  "\n" ;

            }
        } else {
            echo 'Theres no sms to sent';
        }
       
        
    }
}

$sms = new SendSms();
$sms->execute();