<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;
use SMSGatewayMe\Client\Model\CancelMessageRequest;


Class UpdateSmsStatus {

    private $dbc;
    private $config;
    private $apiClient;
    private $messageClient;

    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        ini_set('memory_limit', '2048M');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast") or die(mysqli_connect_error());
    }

    public function execute() {
                

        $dateToday = date('Y-m-d');
    //    $dateYesterday = date('Y-m-d', strtotime($dateToday . ' -1 day'));
        $dateObj = $row['createdAt'];
        
        $q = mysqli_query($this->dbc, "
            SELECT 
                c.`contact_no`,
                c.`message`,
                c.`sms_status`,
                c.`id`,
                c.`sms_id`,
                c.`vetcloud_server`,
                c.`vetcloud_id`,
                DATE_FORMAT(c.`created_at`, '%Y-%m-%d') as createdAt
            FROM `client` c
            WHERE c.`created_at` BETWEEN '".$dateToday." 00:00:00' AND '".$dateToday." 23:59:59'
        ");
        if($q->num_rows > 0){
            while ($row = mysqli_fetch_assoc($q)) {
                
                if($this->validatePhoneNo($row['contact_no'])){
                    if(!mysqli_query($this->dbc, " UPDATE `client` c SET c.`sms_status` = 'New' WHERE c.`id` = '". $row['id'] . "'"))
                die(mysqli_error($this->dbc));

                } else {
                     if(!mysqli_query($this->dbc, " UPDATE `client` c SET c.`sms_status` = 'Invalid Contact No' WHERE c.`id` = '". $row['id'] . "'"))
                                     die(mysqli_error($this->dbc));

                }
                
                         echo $row['id']. ' is successfully updated in system.'  .  "\n"  ;

                // $status = '';
                // if($row['sms_status'] == 'Sent'){
                //     $status = 0;
                // }
                
                // if($row['sms_status'] == 'Invalid Contact No'){
                //     $status = 1;
                // }

                // if(is_int($status)){

                //     try {

                // 	    $curl = curl_init();

                //         curl_setopt_array($curl, array(
                //           CURLOPT_URL => $row['vetcloud_server'] . '/api/SMSSchedule/UpdateSMSScheduleStatus?UniqueID='.urlencode($row["vetcloud_id"]).'&iTextMo_Status=' . $status,
                //           CURLOPT_RETURNTRANSFER => true,
                //           CURLOPT_ENCODING => '',
                //           CURLOPT_MAXREDIRS => 10,
                //           CURLOPT_TIMEOUT => 0,
                //           CURLOPT_FOLLOWLOCATION => true,
                //           CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                //           CURLOPT_CUSTOMREQUEST => 'POST',
                //           CURLOPT_POSTFIELDS => array(),
                //         ));
                        
                //         $response = curl_exec($curl);
                //         curl_close($curl);

                //         $result = json_decode($response,true);

                //         if(isset($result['result']) && isset($result['result']['Success'])){
                //             if($status == 1){

                //                 if(!mysqli_query($this->dbc, " UPDATE `client` c SET c.`sms_status` = 'Invalid No' WHERE c.`id` = '". $row['id'] . "'"))
                //                 die(mysqli_error($this->dbc));

                //             } else {
                               
                //                 if(!mysqli_query($this->dbc, "UPDATE `client` c SET c.`sms_status` = 'Sent In System' WHERE c.`id` = '". $row['id'] . "'"))
                //                  die(mysqli_error($this->dbc));
                //             }
                            
                //             echo $row['id']. ' is successfully updated in system.'  .  "\n"  ;
                        
                //         } 
                        
                //     } catch (Exception $ex) {
                        
                //         echo 'Opps something went wrong please try again later';
                //     }
                // }
             }
        } else {
            echo 'Theres no sms to update';
        }
    }
    
       public function validatePhoneNo($phoneNo){
        
            $isVAlid = false;
            if(preg_match("/^(09|\+639)\d{9}$/", $phoneNo)) {
                $isVAlid = true;
            }
            
            return $isVAlid;
            
        }

}

$sms = new UpdateSmsStatus();
$sms->execute();