<?php 
    
    require 'vendor/autoload.php';

        use PhpOffice\PhpSpreadsheet\Reader\Csv;

        use PhpOffice\PhpSpreadsheet\Spreadsheet;
        use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
        use PhpOffice\PhpSpreadsheet\IOFactory;

        include 'SentAppointmentMessages.php';   
        
         ini_set('memory_limit', '2048M');
         set_time_limit(0);

            $company = isset($_GET['company']) ? $_GET['company'] : '';
           $sendAppointmentSchedule = new SentAppointmentMessages();
           $sentMessages = $sendAppointmentSchedule->getAllSentSms($company);
        
                   

            $rowCtr = 1;

            $spreadsheet = new Spreadsheet();
            $sheet = $spreadsheet->getActiveSheet();
            $sheet->setCellValue('A1', 'Company');
            $sheet->setCellValue('B1', 'Client');
            $sheet->setCellValue('C1', 'Contact No.');
            $sheet->setCellValue('D1', 'Message');
            $sheet->setCellValue('E1', 'Date Created');
            $sheet->setCellValue('F1', 'Date Sent');

            foreach($sentMessages as $sentMessage) {
                $rowCtr++;
                $sheet->setCellValue('A'.$rowCtr, $sentMessage['company']);
                $sheet->setCellValue('B'.$rowCtr, $sentMessage['client']);
                $sheet->setCellValue('C'.$rowCtr, $sentMessage['contact_no']);
                $sheet->setCellValue('D'.$rowCtr, $sentMessage['message']);
                $sheet->setCellValue('E'.$rowCtr, $sentMessage['schedule_date_created']);
                $sheet->setCellValue('F'.$rowCtr, $sentMessage['createdAt']);
            }


            header('Content-type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="text.xlsx"');
            header('Cache-Control: max-age=0');

            ob_end_clean();
            $writer = IOFactory::createWriter($spreadsheet, 'Xlsx');
            $writer->save('php://output');

            die();


    ?>
    <!doctype html>
        <html lang="en">
        <head>
            <!-- Required meta tags -->
            <meta charset="utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1">

            <!-- Bootstrap CSS -->
            <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">        </head>
        <body>
            <div class="container mt-5">
                <div class="row">
                    <div class="col">
                        <a href="/download_sent_sms.php" class="btn btn-primary">Download Sent SMS</a>
                    </div>
                </div>
            </div>
       </body>
    </html>



<?php 

?>