<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

Class SmsGetter {

    private $dbc;
    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast") or die(mysqli_connect_error());
    }

    public function execute() {
         ini_set('memory_limit', '4096M');
        set_time_limit(0);

        $server = $this->server();
        
        print_r($server);
    
        
        if(count($server)){
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => $server[0]['description'] . '/api/SMSSchedule/PendingYesterdayAppointment',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => array(),
            ));
    
            $response = curl_exec($curl);
            curl_close($curl);
           
                        print_r($curl);
            if($response){
    
                $apiRecords = json_decode($response, true);
                $records = $apiRecords['Records'];
                
                if($records != null)
                {
                    foreach($records as $k =>  $record){
                        
                        $msg = $this->dbc->real_escape_string($record['Message']);
                        $no = $this->dbc->real_escape_string($record['ContactNumber_Client']);
                        $company = $this->dbc->real_escape_string($record['Name_Company']);
                        $client = $this->dbc->real_escape_string($record['Name_Client']);
                        $scheduleDateCreated = $this->dbc->real_escape_string($record['DateCreated']);
                        $comment = $this->dbc->real_escape_string($record['Comment']);
                        $item = $this->dbc->real_escape_string($record['Name_Item']);
                        $dateReturn = $this->dbc->real_escape_string($record['DateReturn']);
                        $systemId = $this->dbc->real_escape_string($record['UniqueID']);
                        $code = $this->dbc->real_escape_string($record['Code']);
                        $apiServer = $this->dbc->real_escape_string($apiUrl);
        
        
                        $createdAt = date("Y-m-d h:i:s");
                        if($company != 'TextBlast'){
                                $q = mysqli_query($this->dbc, "
                                SELECT 
                                    c.`contact_no`,
                                    c.`message`,
                                    c.`status`,
                                    c.`id`
                                FROM `client` c
                                WHERE c.`contact_no` = '".$no."' 
                                AND c.`message` = '". $msg."'
                                AND c.`company` = '". $company."'
                                LIMIT 1
                            ");
                        }
        
                    
        
                        if($q->num_rows >  0){
                            while ($row = mysqli_fetch_assoc($q)) {
                                echo " This message is duplicate" . "\n";
                            }
                        } else {
                            
                            $smsStatus = 'Invalid Contact No';
                            $msgId = NULL;
            
                            if($this->validatePhoneNo($no)){
                                $smsStatus = 'New';
                                
                                if($msg == ''){
                                    $smsStatus = 'Invalid Message content';
                                }
        
                                $insertTo = "('".$no."','".$code."', '". $msg."', 0, '". $company."', '". $client."', '". $scheduleDateCreated."', '". $createdAt."', '". $comment."', '". $item."', '". $dateReturn."', '". $systemId."', '". $smsStatus."', '". $apiServer."' )";
                                if(!mysqli_query($this->dbc, "INSERT INTO `client` (`contact_no`, `code`,  `message`, `status`, `company`, `client`, `schedule_date_created`, `created_at`, `comment`, `item`, `date_return`, `vetcloud_id`, `sms_status`, `vetcloud_server`) VALUES $insertTo "))
                                die(mysqli_error($this->dbc));
                            } else {
        
                                $curl = curl_init();
        
                                curl_setopt_array($curl, array(
                                CURLOPT_URL => $apiUrl . '/api/SMSSchedule/UpdateSMSScheduleStatus?UniqueID='.urlencode($systemId).'&iTextMo_Status=1',
                                CURLOPT_RETURNTRANSFER => true,
                                CURLOPT_ENCODING => '',
                                CURLOPT_MAXREDIRS => 10,
                                CURLOPT_TIMEOUT => 0,
                                CURLOPT_FOLLOWLOCATION => true,
                                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                CURLOPT_CUSTOMREQUEST => 'POST',
                                CURLOPT_POSTFIELDS => array(),
                                ));
                                
                                $response = curl_exec($curl);
                                
                                curl_close($curl);
        
                                $insertTo = "('".$no."', '". $code."', '". $msg."', 0, '". $company."', '". $client."', '". $scheduleDateCreated."', '". $createdAt."', '". $comment."', '". $item."', '". $dateReturn."', '". $systemId."', '". $smsStatus."', '". $apiServer."' )";
                                if(!mysqli_query($this->dbc, "INSERT INTO `client` (`contact_no`, `code`, `message`, `status`, `company`, `client`, `schedule_date_created`, `created_at`, `comment`, `item`, `date_return`, `vetcloud_id`, `sms_status`, `vetcloud_server`) VALUES $insertTo "))
                                die(mysqli_error($this->dbc));
                            }
                            
                            echo "Message save to " . $record['ContactNumber_Client'] . ' save to server' . "\n" ;
                        }  
                    
                        if ($k === array_key_last($records)) {
                        if(!mysqli_query($this->dbc, "UPDATE `server` s SET s.`is_pull_2` = 1  WHERE s.`id` = '".$server[0]['id']."'"))
                                    die(mysqli_error($this->dbc));     
                        }
        
                    }

                }
                else
                {
                    if(!mysqli_query($this->dbc, "UPDATE `server` s SET s.`is_pull_2` = 1  WHERE s.`id` = '".$server[0]['id']."'"))
                    die(mysqli_error($this->dbc));     
                }
            } else {
                   //if(!mysqli_query($this->dbc, "UPDATE `server` s SET s.`is_active` = 0  WHERE s.`id` = '".$server[0]['id']."'"))
                   //                die(mysqli_error($this->dbc));   
                   
                   echo 'Unable to run';
            }
        } else {
                 if(!mysqli_query($this->dbc, "UPDATE `server` s SET s.`is_pull_2` = 0  WHERE s.`is_active` = 1"))
                                  die(mysqli_error($this->dbc));   
                                  
                                  $this->execute();
        }

       
               
       
    }
    
    private function composeMessage($msg){
        
        $pattern = '/((http|https)\:\/\/)?[a-zA-Z0-9\.\/\?\:@\-_=#]+\.([a-zA-Z0-9\&\.\/\?\:@\-_=#])*/';
        if (preg_match_all($pattern, $msg, $matches)) {
            
            foreach ($matches as $url) {
                $string = str_replace($url, '', $string);
            }
        } 
        
        return $string;
    }

    public function validatePhoneNo($phoneNo){
        
        $isVAlid = false;
        if(preg_match("/^(09|\+639)\d{9}$/", $phoneNo)) {
            $isVAlid = true;
        }
        
        return $isVAlid;
        
    }
    
    private function server(){
        
        $q = mysqli_query($this->dbc,
            "SELECT 
                 s.`description`,
                 s.`id`
            FROM `server` s
            WHERE is_active = 1
            AND s.`is_pull_2` = 0
            LIMIT 1
        ");
        
        
            
        return mysqli_fetch_all($q, MYSQLI_ASSOC);
        
    }
    

}





$getter = new SmsGetter();
$getter->execute();