<?php 
     require 'vendor/autoload.php';

    Class Helper2{

        private $dbc;

        
        public function __construct() {
            date_default_timezone_set('Asia/Manila');
                $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast2") or die(mysqli_connect_error());
        }

        public function getCompanies(){
            $q = mysqli_query($this->dbc, "
                SELECT DISTINCT
                    c.`company`
                FROM `client` c
          ");
        
        
            $company = [];  
            if($q->num_rows >  0){
                while ($row = mysqli_fetch_assoc($q)) {
                    
                    array_push($company,$row['company']);
                    
                }
            } 
            return $company;

        } 

        public function getData($formData){
            
            $sqlWhere = '';
            $sqlParams = [];

            if(isset($formData['company']) && !empty($formData['company'])){
                $sqlWhere .= ' AND c.`company` = "' .$formData['company'] . '"';
            }

            if(isset($formData['status']) && !empty($formData['status'])){
                $sqlWhere .= ' AND c.`sms_status` = "' .  $formData['status'] . '"'; 
            }

            if(isset($formData['date']) && !empty($formData['date'])){
                $startDate = date('Y-m-d', strtotime($formData['date'])) . ' 00:00:00';
                $endDate = date('Y-m-d', strtotime($formData['date'])) . ' 23:59:59';  
                $sqlWhere .= ' AND c.`created_at`  BETWEEN "' .$startDate. '" AND "'.$endDate.' "';
                
            }

            $q = mysqli_query($this->dbc, "SELECT 
                    c.`contact_no`,
                    c.`message`,
                    c.`status`,
                    c.`client`,
                    c.`company`,
                    c.`schedule_date_created`,
                    c.`item`,
                    c.`comment`,
                    c.`date_return`,
                    c.`id`,
                    DATE_FORMAT(c.`created_at`, '%Y/%m/%d') as createdAt
                FROM `client` c
                WHERE c.`id` IS NOT NULL
                ".$sqlWhere."
                AND c.`contact_no` IS NOT NULL
                AND c.`message`  IS NOT NULL
                AND c.`company` IS NOT NULL
                AND c.`client`  IS NOT NULL");
        
            
            return mysqli_fetch_all($q, MYSQLI_ASSOC);
        }
        
        public function updateStatus($id, $status){
            
          if(!mysqli_query($this->dbc, "UPDATE `client` c SET c.`sms_status` = '".$status."', c.`status` = 1, c.`updated_at` = NOW()  WHERE c.`id` = ".$id.""));

        }

    }

?>