<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;
use SMSGatewayMe\Client\Model\CancelMessageRequest;


Class UpdateMessageContentUrl {

    private $dbc;
    private $config;
    private $apiClient;
    private $messageClient;

    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        ini_set('memory_limit', '2048M');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast") or die(mysqli_connect_error());
    }

    public function execute() {
                

        $dateToday = date('Y-m-d');
        $dateYesterday = date('Y-m-d', strtotime($dateToday . ' -1 day'));
        $dateObj = $row['createdAt'];
        
        $q = mysqli_query($this->dbc, "
            SELECT 
                c.`contact_no`,
                c.`message`,
                c.`sms_status`,
                c.`id`,
                c.`sms_id`,
                c.`vetcloud_server`,
                c.`vetcloud_id`,
                DATE_FORMAT(c.`created_at`, '%Y-%m-%d') as createdAt
            FROM `client` c
            WHERE c.`created_at` >= '".$dateYesterday." 00:00:00'
        ");
        if($q->num_rows > 0){
            while ($row = mysqli_fetch_assoc($q)) {
                
       
                     
                    $msg = $this->dbc->real_escape_string(str_replace(' E-mail: mevetcare.office@gmail.com', '', $row['message']));
                     if(!mysqli_query($this->dbc, " UPDATE `client` SET `message` = '".$msg."'  WHERE `id` = '". $row['id'] . "'"))
                                     die(mysqli_error($this->dbc));
                            echo 'update ' . $row['id'];

             }

        } else {
            echo 'Theres no sms to update';
        }
    }
    
       public function validatePhoneNo($phoneNo){
        
            $isVAlid = false;
            if(preg_match("/^(09|\+639)\d{9}$/", $phoneNo)) {
                $isVAlid = true;
            }
            
            return $isVAlid;
            
        }

}

$sms = new UpdateMessageContentUrl();
$sms->execute();