<?php

    require '../vendor/autoload.php';
    include '../Helper.php'; 
    
    $helper = new Helper();
    $data = [ ];
    
    if($_SERVER['REQUEST_METHOD'] != 'POST'){
    
        $data['success'] = false;
        $data['msg'] = 'Invalid request';
    } else {
        
        if(!isset($_POST['UniqueID'])){
            
            $data['success'] = false;
            $data['msg'] = 'Missing required parameters.';
        } else {
            
            $vetcloudId = $_POST['UniqueID'];
            $d = $helper->getStatus($vetcloudId);
            
            if(count($d) > 0){
                
                if($d[0]['sms_status'] == 'Sent'){
                    
                    $data['status'] = 0;
                    $data['date_sent'] = $d[0]['dateSent'];
                } else if($d[0]['sms_status'] == 'Invalid Contact No') {
                    
                    $data['status'] = 1;
                }
            } else {
                
                $data['success'] = false;
                $data['msg'] = 'Invalid parameters.';
            }
            
        }    
    }
    
    
    echo json_encode($data); 
?>

