<?php

session_start();

require 'vendor/autoload.php';

if (isset($_SESSION['id']) && isset($_SESSION['user_name'])) {

    ?>
    <!DOCTYPE html>
    <html>

    <head>
        <meta charset="utf-8">
        <link rel="shortcut icon" type="image/ico" href="https://www.datatables.net/favicon.ico">
        <meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1.0, user-scalable=no">
        <title>TextBlast</title>
        <link rel="stylesheet" type="text/css" href="../../media/css/jquery.dataTables.css">
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
        <script type="text/javascript" language="javascript" src="https://code.jquery.com/jquery-3.5.1.js"></script>
        <script type="text/javascript" language="javascript" src="../../media/js/jquery.dataTables.js"></script>
        <script type="text/javascript" language="javascript" class="init">
            $(document).ready(function() {
                var table = $('#table').DataTable({
                    processing: true,
                    serverSide: true,
                    "lengthChange": false,
                    ajax: {
                        url: '/scripts/server_processing.php',
                        data: function(d) {
                            d.sms_status = $('#status').val()
                        }
                    }
                });

                $('#status').unbind('change').bind('change', function() {
                    table.draw();
                });
            });
        </script>
    </head>

    <body class="dt-example">
        <?php include 'navbar.php'; ?>

        <div class="container">
            <section class='mt-5'>
                <div class='row'>
                    <div class='col-3'>
                        <label for="staus" class="form-label">Status</label>
                        <select id='status' class='form-control'>
                            <option value=''> All</option>
                            <option value='New'> New</option>
                            <option value='Sent'> Sent</option>
                        </select>
                    </div>
                </div>

                <div class='row'>
                    <div class='col'>
                        <div class="demo-html">
                            <table id="table" class="display table" style="width:100%">
                                <thead>
                                    <tr>
                                        <th>Contact No.</th>
                                        <th>Message</th>
                                        <th>Status</th>
                                    </tr>
                                </thead>
                                <tbody></tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </section>
        </div>
        <section>
    </body>

    </html>

<?php
} else {
    header("Location: index.php");
    exit();
}
?>