<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

header("Content-Type: application/json");
header('Access-Control-Allow-Origin: *');
$api = new Api();
$api->execute();

echo json_encode($api->data);

Class Api {

    private $dbc;
    public $data;

    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcawnj_dev", "!tryMe123", "vetcawnj_textblast") or die(mysqli_connect_error());
    }
    
     public function execute() {
        
        $this->data = [];
        $dateToday = date('Y-m-d');
        $dateYesterday = date('Y-m-d', strtotime($dateToday . ' -1 day'));
        $dateObj = $row['createdAt'];
        $q = mysqli_query($this->dbc, "
            SELECT 
                c.`contact_no`,
                c.`message`,
                c.`status`,
                c.`id`,
                c.`sms_id`,
                c.`vetcloud_server`,
                c.`vetcloud_id`,
                DATE_FORMAT(c.`created_at`, '%Y-%m-%d') as createdAt
            FROM `client` c
            WHERE c.`sms_status` = 'Sent' 
            AND c.`created_at` BETWEEN '".$dateYesterday." 00:00:00' AND '".date('Y-m-d')." 23:59:59' 
            AND c.`status`  = 1
            LIMIT 1
        ");

        if($q->num_rows > 0){
            $ctr = 0;
           
            while ($row = mysqli_fetch_assoc($q)) {
              array_push($this->data, array(
                'id' => $row['id'],
                'contact_no' => $row['contact_no'],
                'vetcloud_server' => $row['vetcloud_server'],
                'vetcloud_id' => $row['vetcloud_id'],
                ));
                if($ctr == 40){
                    break;
                }
                
                    
            }
        }
     }
}
